package at.ac.uibk.gitsearch.repository.jpa;

import at.ac.uibk.gitsearch.domain.ReviewRating;
import at.ac.uibk.gitsearch.domain.User;
import at.ac.uibk.gitsearch.domain.enumeration.ReviewStatus;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

public interface ReviewRatingRepository extends JpaRepository<ReviewRating, Long> {
    /**
     * just a nice holder interface for status count
     *
     * @author Michael Breu
     *
     */
    interface StatusAndCount {
        ReviewStatus getStatus();

        Integer getStatusCount();
    }

    void deleteByReviewId(Long reviewId);

    List<ReviewRating> findAllByUserId(Long userId);

    @Query("SELECT rr.status as status, count(*) as statusCount from ReviewRating rr WHERE rr.user = :user group by status")
    List<StatusAndCount> countReviewsForUserByStatus(@Param("user") User user);
}
